-- 1) Criar a tabela PLAN_TABLE

create table PLAN_TABLE (
	statement_id 	varchar2(30),
	timestamp    	date,
	remarks      	varchar2(80),
	operation    	varchar2(30),
	options       	varchar2(255),
	object_node  	varchar2(128),
	object_owner 	varchar2(30),
	object_name  	varchar2(30),
	object_instance numeric,
	object_type     varchar2(30),
	optimizer       varchar2(255),
	search_columns  number,
	id		numeric,
	parent_id	numeric,
	position	numeric,
	cost		numeric,
	cardinality	numeric,
	bytes		numeric,
	other_tag       varchar2(255),
	partition_start varchar2(255),
   partition_stop  varchar2(255),
   partition_id    numeric,
	other		long,
	distribution    varchar2(30),
	cpu_cost	numeric,
	io_cost		numeric,
	temp_space	numeric,
   access_predicates varchar2(4000),
   filter_predicates varchar2(4000));

--2) Criar statement no identificado

explain plan 
for select sysdate from dual;

--ver plano de execuo no identificado

SELECT LPAD(' ',2*(LEVEL-1))||operation||' '||options
   ||' '||object_name
   ||' '||DECODE(id, 0, 'Cost = '||position) "Query Plan"
   FROM plan_table
   START WITH id = 0
   CONNECT BY PRIOR id = parent_id;


-- antes de executar o prximo explain plan  necessrio truncar a tabela PLAN_TABLE


-- 3) Criar plano de execuo identificado
--    Permite armazenar vrios planos em simultneo, identificados pelo ID
explain plan 
set statement_id = '1'
for select sysdate from dual;

--ver plano de execuo identificado

SELECT LPAD(' ',2*(LEVEL-1))||operation||' '||options
   ||' '||object_name
   ||' '||DECODE(id, 0, 'Cost = '||position) "Query Plan"
   FROM plan_table
   START WITH id = 0 AND statement_id = '1'
   CONNECT BY PRIOR id = parent_id AND statement_id = '1'
;

-- Se usarmos um id diferente podemos inserir mais planos sem truncar a tabela